function sanitize(string) {
    string = String(string);
  const map = {
      '&': '&amp;',
      '<': '&lt;',
      '>': '&gt;',
      '"': '&quot;',
      "'": '&#x27;',
      "/": '&#x2F;',
      "`": '&grave;'
  };
  const reg = /[&<>"'/`]/ig;
  return string.replace(reg, (match)=>(map[match]));
}

function blinkRed($elem) {
    let origCol = $elem.css('color');
    $elem.css('color', 'red');
    setTimeout(_ => {
        $elem.css('color', origCol);

        setTimeout(_ => {
            let origCol1 = $elem.css('color');
            $elem.css('color', 'red');
            setTimeout(_ => {
                $elem.css('color', origCol);
            }, 290);
        }, 200);
    }, 290);
}

function scrollToId(id) {
    let element_to_scroll_to = $('#'+id)[0];
    element_to_scroll_to.scrollIntoView();
}

function validationErrorHandler(labelFor, scrollTo){
    scrollToId(scrollTo);
    setTimeout(function(){
        blinkRed($("label[for='"+labelFor+"']"));
    }, 250);
}

$(document).ready(_ => {
    $("#outputFormatDiv input").on('change', e => {
    //console.log(e);
    //let currentFormat = $("#outputFormatInp").val().split(',');
    let currentFormat = $("#flowFormatDiv li").toArray().map(el => {return el.innerText});
    //console.log(currentFormat);

    if (!currentFormat.includes(e.target.id)) {
        /*if (currentFormat[0] === "")
            currentFormat.splice(0,1);
        currentFormat.push(e.target.id);
        console.log(currentFormat);
        $("#outputFormatInp").val(currentFormat.join(','));*/

        currentFormat.push(e.target.id);
    }
    else {
        /*let i = currentFormat.indexOf(e.target.id);
        if (i !== -1)
            currentFormat.splice(i, 1);
        $("#outputFormatInp").val(currentFormat.join(','));*/

        let i = currentFormat.indexOf(e.target.id);
        if (i !== -1)
            currentFormat.splice(i, 1);
    }

    /*let checkedItems = [];
    for (let i of $("#outputFormatDiv input")){
        if (i.checked === true)
            checkedItems.push(i);
    }
    console.log(checkedItems);*/
    //console.log(currentFormat);
    //debugger;


    //$("#outputFormatInp").val(currentFormat.map(el => el.id).join(','));

    $("#flowFormatDiv").html(currentFormat.map(el => `<li class="ui-state-default ui-sortable-handle flowFormatElem label label-default">${el}</li>`).join(''))


});
    $("#searchTableInp").on('input', _ => {
        let search = $("#searchTableInp").val().toLowerCase();
        if (search.length < 1){
            $("#outputFormatDiv input,#outputFormatDiv label").css('background-color', 'transparent');
            $("#foundResults").html(``);
            return;
        }

        let found = [];

        let allInps = $("#outputFormatDiv input,#outputFormatDiv label");

        for (let i = 0; i < allInps.length; i += 2){
            allInps[i].style.backgroundColor = 'transparent';
            allInps[i+1].style.backgroundColor = 'transparent';
            if (allInps[i].id.includes(search) || allInps[i+1].innerText.toLowerCase().includes(search)){
                found.push(allInps[i]);
                found.push(allInps[i+1]);
            }
        }
        // hide everything except found inputs
        //$("#outputFormatDiv input,#outputFormatDiv label").hide();
        for (let el of found) {
            el.style.backgroundColor = 'green';
        }

        $("#foundResults").html(`Found ${found.length/2} items`);

    });
    $("#sameConsoleAddrCB").change(function() {
        if(this.checked) {
            $("#hostWebConsoleAddress").prop('disabled', true);
            if ($("#hostWebConsoleAddress").val().length < 1)
                $("#hostWebConsoleAddress").val($("#hostAddress").val());
        }
        else {
            $("#hostWebConsoleAddress").prop('disabled', false);
        }
    });
    $("#hostAddress").on('input', _ => {
        if ($("#sameConsoleAddrCB").prop('checked')) {
            $("#hostWebConsoleAddress").val($("#hostAddress").val());
        }
    });
    $("#verifyHttps").change(function() {
        console.log("changing verifyHttps", this.checked)
        if(this.checked){
            $("#certSpan").show();
        }
        else {
            $("#certSpan").hide();
        }
    });
    $("#proxyEnabled").change(function() {
        if(this.checked){
            $("#proxyData").show();
        }
        else {
            $("#proxyData").hide();
        }
    });
    $("#useDefaultBtn").on('click', _ => {
        $("#outputFormatDiv input").prop( "checked", false );
        $("#flowFormatDiv").html('');

        let defFormat = ['ts', 'td', 'pr', 'sa', 'sp', 'da', 'dp', 'flg', 'tos', 'pkt', 'byt', 'fl'];

        for (let f of defFormat){
            $("#flowFormatDiv").append(`<li class="ui-state-default ui-sortable-handle flowFormatElem label label-default">${f}</li>`);
            $(`#${f}`).prop('checked', true);
        }
    });
    $(".toggleAllBtns").on('click', e => {
        let tmp = Array.from(e.target.parentElement.parentElement.children).slice(1);
        let inputs = tmp.map(el => {return el.children[0]});
        //console.log(inputs);
        let checkedItems = 0;
        for (el of inputs) {
            if (el.checked)
                checkedItems += 1;
        }

        if (checkedItems > inputs.length/2){
            for (el of inputs) {
                el.checked = true;
                el.click();
            }
        }
        else{
            for (el of inputs) {
                el.checked = false;
                el.click();
            }
        }

        //console.log(checkedItems);
    });

    $("#saveBtn").on('click', _ => {
        $("#alertSave").html("").removeClass("alert-danger");

        let selectedFormat = $("#flowFormatDiv li").toArray();

        if ($("#hostAddress").val().length < 1){
            validationErrorHandler('hostAddress', 'mainSettingsHeader');
            return
        }

        if ($("#hostWebConsoleAddress").val().length < 1){
            validationErrorHandler('hostWebConsoleAddress', 'mainSettingsHeader');
            return
        }

        if ($("#username").val().length < 1){
            validationErrorHandler('username', 'mainSettingsHeader');
            return;
        }

        if ($("#compTimeout").val().length < 1){
            validationErrorHandler('compTimeout', 'mainSettingsHeader');
            return;
        }

        if ($("#verifyHttps").prop('checked')){
            if ($("#certFile").prop('files').length === 0){
                validationErrorHandler('certFile', 'mainSettingsHeader');
                return
            }
        }

        if ($("#proxyEnabled").prop('checked')){
            if ($("#proxyAddress").val().length < 1){
                validationErrorHandler('proxyAddress', 'proxyHeader');
                return;
            }
            if ($("#proxyPort").val().length < 1){
                validationErrorHandler('proxyPort', 'proxyHeader');
                return;
            }
        }

        if (selectedFormat.length < 1){
            validationErrorHandler('outputFormatInp', 'loggingHeader');
            return
        }

        let obj = {
            host: $("#hostAddress").val(),
            webConsole: $("#hostWebConsoleAddress").val(),
            username: $("#username").val(),
            password: $("#password").val(),
            componentTimeout: $("#compTimeout").val(),
            verifyHttps: $("#verifyHttps").prop('checked'),
            proxy: {
                enabled: $("#proxyEnabled").prop('checked'),
                address: $("#proxyAddress").val(),
                port: $("#proxyPort").val(),
                username: $("#proxyUsername").val(),
                password: $("#proxyPassword").val(),
            },
            flowFormatExternal: selectedFormat.map(el => {
                return $("#"+el.innerText).attr('data-alt');
            }),
            flowFormatInternal: selectedFormat.map(el => el.innerText),
            logLevel: parseInt($("#debugLevel").val())
        };

        /*if ($("#proxyPassword").val().length < 1)
            obj.password = false;
        else
            obj.password = $("#password").val();

        if ($("#proxyPassword").val().length < 1)
            obj.proxy.password = false;
        else
            obj.proxy.password = $("#proxyPassword").val();*/


        $("#saveBtnSpan").html('Saving...');
        if ($("#verifyHttps").prop('checked')) {
                let fd = new FormData();
                fd.append('file', $("#certFile").prop('files')[0]);
                $.ajax({
                    type: 'POST',
                    url: 'config_cert',
                    data: fd,
                    processData: false,
                    contentType: false
                }).done(_ => {
                    $.ajax({
                        method: 'POST',
                        url: 'config',
                        data: JSON.stringify(obj),
                        contentType: "application/json"
                    }).done( _ => {
                        $("#saveBtnSpan").html('Success');
                        $("#saveBtn").addClass('btn_success');
                        setTimeout(_ => {
                            $("#saveBtn").removeClass('btn_success');
                            $("#saveBtnSpan").html('Save');
                        }, 2500);
                    }).fail(_ => {
                        $("#saveBtnSpan").html('Error');
                        $("#saveBtn").addClass('btn_error');
                        setTimeout(_ => {
                            $("#saveBtn").removeClass('btn_error');
                            $("#saveBtnSpan").html('Save');
                        }, 2500);
                    })
                }).fail(_ => {
                    $("#saveBtnSpan").html('Error');
                    $("#saveBtn").addClass('btn_error');
                    setTimeout(_ => {
                        $("#saveBtn").removeClass('btn_error');
                        $("#saveBtnSpan").html('Save');
                    }, 2500);
                })
            }

        else {
            $.ajax({
            method: 'POST',
            url: 'config',
            data: JSON.stringify(obj),
            contentType: "application/json"
            }).done( resp => {
                $("#saveBtnSpan").html('Success');
                $("#saveBtn").addClass('btn_success');
                setTimeout(_ => {
                    $("#saveBtn").removeClass('btn_success');
                    $("#saveBtnSpan").html('Save');
                }, 2500);
            }).fail((a, b, c) => {
                console.log(sanitize(a.responseText));
                $("#saveBtnSpan").html('Error');
                $("#saveBtn").addClass('btn_error');
                setTimeout(_ => {
                    $("#saveBtn").removeClass('btn_error');
                    $("#saveBtnSpan").html('Save');
                }, 2500);
            })
        }

    });

    $("#outputFormatInp").val('');
    $("#searchTableInp").val('');
    $("#hostAddress").val('');
    $("#hostWebConsoleAddress").val('');
    $("#username").val('');
    $("#password").val('');
    $("#outputFormatDiv input").prop('checked', false);
    $("#verifyHttps").prop('checked', false);
    $("#proxyEnabled").prop('checked', false);
    $("#sameConsoleAddrCB").prop('checked', false);
    $("#debugLevel").val(2);


    $.get('config').done(r => {
        $("#password").val('');
        r = JSON.parse(r);
        $("#hostAddress").val(r['host']);
        $("#hostWebConsoleAddress").val(r['webConsole']);
        $("#username").val(r['username']);
        $("#compTimeout").val(r['componentTimeout']);
        $("#outputFormatInp").val(r['flowFormatInternal'].join(','));
        if (r['host'] === r['webConsole']) {
            $("#sameConsoleAddrCB").prop('checked', true);
            $("#hostWebConsoleAddress").prop('disabled', true);
        }

        $("#verifyHttps").prop('checked', r['verifyHttps']).change();

        $("#proxyEnabled").prop('checked', r['proxy']['enabled']).change();
        $("#proxyAddress").val(r['proxy']['address']);
        $("#proxyPort").val(r['proxy']['port']);
        $("#proxyUsername").val(r['proxy']['username']);
        $("#proxyPassword").val(r['proxy']['password']);

        $("#debugLevel").val(r['logLevel']);
        for (let f of r['flowFormatExternal']) {
            let $elem = $(`input[data-alt='${f}']`);
            //console.log($elem);
            $elem.prop('checked', true);
            $("#flowFormatDiv").append(`<li class="ui-state-default ui-sortable-handle flowFormatElem label label-default">${$elem.attr('id')}</li>`);
        }
    })
});