var dtFlows;
function validateDataFlows() {
    if ( new Date($('#fromInpFlows').val()) > new Date($('#toInpFlows').val()) ){
        blinkRed($("label[for='fromInpFlows']"));
        blinkRed($("label[for='toInpFlows']"));
        return false
    }
    return true
}

$('#fromInpFlows').val(_ => {
    let d = new Date();
    //d.setDate(d.getHours() - 6);
    d.setHours(d.getHours() - 6);
    let y = d.getFullYear();
    let mon = d.getMonth() + 1;
    if (mon < 10) mon = '0' + mon;
    let day = d.getDate();
    if (day < 10) day = '0' + day;
    let h = d.getHours();
    if (h < 10) h = '0' + h;
    let m = d.getMinutes();
    if (m < 10) m = '0' + m;
    let res = `${y}-${mon}-${day} ${h}:${m}`;
    return res;
}).datetimepicker({
    format: 'Y-m-d H:i'
});

$('#toInpFlows').datetimepicker({
    value: new Date(),
    format: 'Y-m-d H:i'
});

$("#channelsInpFlows").multiselect({
    includeSelectAllOption: true,
    selectAllValue: 'select-all-value'
});

$("#openSearchPanelFlows").on('click', _ => {
    $("#searchParamsDivFlows").collapse('toggle');
});

$("#applyToEventsFromFlowBtn").on('click', _ => {
    if (!validateDataFlows())
        return false;

    $("#searchParamsDivFlows").collapse('hide');
    let opts = {
        from: $('#fromInpFlows').val(),
        to: $('#toInpFlows').val()
    };
    if ( $("#filterInpFlows").val().length > 0 ){
        let filterVal = $("#filterInpFlows").val().toLowerCase().replace(/  +/g, ' ');
        let filterValArr = filterVal.split(' ');
        let srcElemIndex = filterValArr.findIndex(el => el === 'src');
        let dstElemIndex = filterValArr.findIndex(el => el === 'dst');
        if (srcElemIndex !== -1)
            opts.source = filterValArr[srcElemIndex + 2];
        if (dstElemIndex !== -1)
            opts.target = filterValArr[dstElemIndex + 2];
    }
    //console.log(opts);
    $("#clearFiltersBtnEvents").click();
    switchToEvents(opts);
});

$("#applyBtnFlows").on('click', _ => {
    if (!validateDataFlows())
        return false;

    $("#flowAlert").removeClass('alert-danger').html('').hide();

    $("#searchParamsDivFlows").collapse('hide');
    let url = `api/flows?from=${$('#fromInpFlows').val()}&to=${$('#toInpFlows').val()}`;

    $("#fromInfoValFlows").html($('#fromInpFlows').val());
    $("#toInfoValFlows").html($('#toInpFlows').val());

    $("#tableDivFlows").hide();
    $("#loadGifFlows").show();

    if ($("#profileInpFlows").val().length > 0) {
        url += `&profile=${$("#profileInpFlows ").val()}`;
        $("#profileInfoValFlows").html($("#profileInpFlows option:selected").text());
    }
    if ($("#channelsInpFlows").val().length > 0) {
        let channelsUrl = "["+$("#channelsInpFlows").val().map(el=>{return '"'+el+'"'})+']';

        url += `&channels=${$("#channelsInpFlows").val()}`;
        //url += `&channels=${channelsUrl}`;
        //$("#channelsInfoValFlows").html($("#channelsInpFlows option:selected").text());
        if ($("#channelsInpFlows option:selected").toArray().length < 4) {
            let tmpChannels = $("#channelsInpFlows option:selected").toArray().map(el => {
                //console.log('el: ', el, el.text);
                return el.text
            }).join(', ');
            //console.log('TmpChannels: ', tmpChannels);
            $("#channelsInfoValFlows").html(tmpChannels);
        }
        else {
            let allChannels = $("#channelsInpFlows option:selected").toArray().map(el => {return el.innerText});
            let shownCh = allChannels.slice(0,3);
            $("#channelsInfoValFlows").html(shownCh.join(', ') + `<span title="${allChannels}"> and ${allChannels.length - shownCh.length} more...</span>`);
        }
    }
    if ($("#countInpFlows").val().length > 0){
        url += `&count=${parseInt($("#countInpFlows").val())}`;
    }
    url += `&listing={}`;

    if ($("#filterInpFlows").val().length === 0)
        url += `&filter=any`;
    else
        url += `&filter=${$("#filterInpFlows").val()}`;

    $.ajax({
        url: url,
        timeout: parseInt(localStorage.getItem('components_timeout'))
    }).done((r, rr, rrr) =>
    {
        if (rrr['status'] === 204) {
            $("#tableDivFlows").html(`<div class="center-block text-center" style="margin-top:15px"> No data</div>`);
            $("#tableDivFlows").show();
            $("#loadGifFlows").hide();
            return;
        }
        else {
            try {
                 r = JSON.parse(r);
            }
            catch (e) {
                $("#flowAlert").addClass('alert-danger').show().html(`
                    Error occured while processing request.<br>Check values and try again.
                `);
            }
            for (let rr of r){
                //console.log("Sanitizing ", rr);
                for (let k in rr) {
                    rr[k] = sanitize(rr[k])
                }
            }

            let tableHTML = `<table id="flowsTableFlows" class="table table-striped"><thead><tr>`;
            let cols = [];
            for (let outp of JSON.parse(localStorage.getItem('flowFormatExternal'))) {
                tableHTML += `<td>${outputDefinitions[outp]}</td>`;
                cols.push({name: outp, data: outp});
            }
            tableHTML += `</tr></thead><tbody></tbody></table>`;
            $("#tableDivFlows").html(tableHTML);
            /*for (let flow of r) {
                let row = `<tr>`;
                for (let key of Object.keys(flow)) {
                    row += `<td>${flow[key]}</td>`;
                }
                row += `</tr>`;
                $("#flowsTableFlows tbody").append(row);
            }*/

            $("#tableDivFlows").show();
            dtFlows = $('#flowsTableFlows').DataTable({
                data: r,
                columns: cols,
                scrollY: '500px',
                scrollCollapse: true,
                responsive: false,
                "pagingType": "input",
                scrollX: true,
                bAutoWidth: false,
                language: {
                    search: "Search in table: "
                },
            });
            $("#loadGifFlows").hide();

        }
    }).fail((r, rr, rrr) => {
        //console.log(r, rr, rrr);

        if (rr === 'timeout'){
            $("#loadGifFlows").hide();
            $("#flowAlert").addClass('alert-danger').show().html(`
                Request timeout<br>Try increase timeout value in configuration or adjust your search parameters
            `);
        }

        else {
            $("#loadGifFlows").hide();
            $("#flowAlert").addClass('alert-danger').html(sanitize(r.responseText)).show();
        }
    } );
});

$("#clearFiltersBtnFlows").on('click', _ => {
    (function(){
        let d = new Date();
        //d.setDate(d.getDate() - 1);
        d.setHours(d.getHours() - 6);
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        $('#fromInpFlows').val(res);
    })();
    (function(){
        let d = new Date();
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        $('#toInpFlows').val(res);
    })();
    $("#filterInpFlows").val('');
    //$("#profileInpFlows").val( $("#profileInpFlows").children()[0].value );
    $("#profileInpFlows").val("live").change()
    $(".profileInputs").change();
    $("#countInpFlows").val("100")
});

$(".profileInputs").change();

let optionAllSources = '';
for( let option of $("#profileInpFlows option")){
    //console.log("opt: ", option);
    if (option.innerText === 'All Sources'){
        optionAllSources = option;
        //console.log('Found');
        break;
    }
}
if (optionAllSources !== '') {
    $("#profileInpFlows").val(optionAllSources.value);
    $(".profileInputs").change();
}


$("#applyBtnFlows").click();

